using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.IO;
using Syncfusion.Windows.Forms.Grid;


namespace GridPrintCopy
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl grid1;
		private System.Windows.Forms.Button btnPreview;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private GridHelper helper;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.btnPreview = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.grid1)).BeginInit();
			this.SuspendLayout();
			// 
			// grid1
			// 
			this.grid1.Location = new System.Drawing.Point(32, 56);
			this.grid1.Name = "grid1";
			this.grid1.Size = new System.Drawing.Size(448, 256);
			this.grid1.TabIndex = 0;
			this.grid1.Text = "gridControl1";
			// 
			// btnPreview
			// 
			this.btnPreview.Location = new System.Drawing.Point(40, 16);
			this.btnPreview.Name = "btnPreview";
			this.btnPreview.Size = new System.Drawing.Size(104, 23);
			this.btnPreview.TabIndex = 1;
			this.btnPreview.Text = "Print Preview";
			this.btnPreview.Click += new System.EventHandler(this.btnPreview_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 358);
			this.Controls.Add(this.btnPreview);
			this.Controls.Add(this.grid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.grid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			helper = new GridHelper(grid1,false);
			helper.CreateGrid();
		}

		private void btnPreview_Click(object sender, System.EventArgs e)
		{
			// create 2nd copy of grid, using Save/LoadBinary
			System.IO.MemoryStream s = new System.IO.MemoryStream();
			grid1.Model.SaveBinary( s );
			s.Position = 0;

			GridModel m = GridModel.LoadBinary( s );
			GridControl gridPrint = new GridControl( m );

			// use the helper class to setup the volitile format/data
			GridHelper helper = new GridHelper(gridPrint,true);
			helper.CreateGrid();
			gridPrint.Refresh();

			// now print preview the print grid
			GridPrintDocument pd = new GridPrintDocument(gridPrint, true); 
			PrintPreviewDialog dlg = new PrintPreviewDialog() ;
			dlg.Document = pd;
			dlg.ShowDialog();
		}


	}	// class

	class GridHelper
	{
		private GridControl grid;
		private bool preview;

		public GridHelper( GridControl grid, bool preview  )
		{
			this.grid = grid;
			this.preview = preview;
		}

		public void CreateGrid()
		{
			grid.ResetVolatileData();

			grid.QueryRowCount += new GridRowColCountEventHandler(grid_QueryRowCount);
			grid.QueryColCount += new GridRowColCountEventHandler(grid_QueryColCount);
			grid.QueryCellInfo += new GridQueryCellInfoEventHandler(grid_QueryCellInfo);
		}

		private void grid_QueryRowCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = 10;
			e.Handled = true;
		}

		private void grid_QueryColCount(object sender, GridRowColCountEventArgs e)
		{
			e.Count = 5;
			e.Handled = true;
		}

		private void grid_QueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
		{
			e.Style.Text = String.Format( "{0} {1}", e.RowIndex, e.ColIndex );
			if ( preview == false )
				e.Style.BackColor = Color.LightBlue;
			else 
				e.Style.BackColor = Color.Red;

			e.Handled = true;
		}
	}	// class GridHelper

}
